#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include <stdarg.h>

#include "signature.h"
#include "patcher.h"
#include "types.h"

using namespace std;

game_info_t game_info = {
  2,
  {
    { "91070_68k.8", // 9th Jan. 1992
      0x20000, /* ROM size */
      0x121C3AE7, /* ROM CRC */
      0,
    },
    { "91070_68k.7", // 9th Jan. 1992
      0x20000, /* ROM size */
      0x6E154D8E, /* ROM CRC */
      0,
    },
  },
};

void patch_7rom()
{
  uint32_t patch0_addr = 0x00000000;
  uint8_t patch0_data[] = {
    0x07, 0xE0, 
  };
  APPLY_PATCH(0);

  uint32_t patch1_addr = 0x000047C7;
  uint8_t patch1_data[] = {
    0xB8, 0x40, 0xD1, 
  };
  APPLY_PATCH(1);

  uint32_t patch2_addr = 0x00004990;
  uint8_t patch2_data[] = {
    0xC0, 0x0A, 0x74, 
  };
  APPLY_PATCH(2);

  uint32_t patch3_addr = 0x000061AE;
  uint8_t patch3_data[] = {
    0x45, 0x02, 0xA3, 0x5F, 
  };
  APPLY_PATCH(3);

  uint32_t patch4_addr = 0x0000696F;
  uint8_t patch4_data[] = {
    0x80, 0x0D, 0x8E, 
  };
  APPLY_PATCH(4);

  uint32_t patch5_addr = 0x00006E27;
  uint8_t patch5_data[] = {
    0xB9, 0x8D, 0xE8, 0x83, 
  };
  APPLY_PATCH(5);

  uint32_t patch6_addr = 0x00008328;
  uint8_t patch6_data[] = {
    0x37, 0x37, 0x4F, 0x77, 0x7A, 0x7F, 0x7E, 0xF7, 0x8F, 0x76, 0xE2, 0x60, 0x76, 0x72, 0xD8, 0x62, 
    0x98, 0x76, 0xB9, 0x86, 0x03, 
  };
  APPLY_PATCH(6);

  uint32_t patch7_addr = 0x0000833E;
  uint8_t patch7_data[] = {
    0x0F, 0x89, 0x7D, 0x88, 0x0F, 0x7D, 0x7E, 0x03, 0x4F, 0x7A, 0x74, 0x0F, 0x7D, 0x88, 0x74, 0x03, 
    0x71, 0x70, 0x72, 0xF1, 0x72, 0x71, 0x78, 0x72, 0xF1, 0x7A, 0x03, 
  };
  APPLY_PATCH(7);

  uint32_t patch8_addr = 0x0000835A;
  uint8_t patch8_data[] = {
    0x76, 0x7B, 0x7C, 0x76, 0x76, 0x76, 0x76, 0x76, 0x76, 0x76, 0x76, 0x76, 0x76, 0x76, 0x76, 0x7B, 
    0x7E, 0x76, 0x36, 0x22, 0x3A, 0x56, 0x76, 0x3A, 0x26, 0x72, 0x3E, 0x26, 0x76, 
  };
  APPLY_PATCH(8);

  uint32_t patch9_addr = 0x00008378;
  uint8_t patch9_data[] = {
    0x76, 0x7B, 0x7C, 0x52, 0x4E, 0x3A, 0x62, 0x3E, 0x26, 0x76, 0x7A, 0x4A, 0x52, 0x4E, 0x0B, 0x06, 
    0x56, 0x56, 0x56, 0xF0, 0xEE, 0x18, 
  };
  APPLY_PATCH(9);

  uint32_t patch10_addr = 0x00008390;
  uint8_t patch10_data[] = {
    0x0B, 0x1A, 0x56, 0x56, 0x56, 0xFE, 0xEE, 0xFD, 
  };
  APPLY_PATCH(10);

  uint32_t patch11_addr = 0x0000839A;
  uint8_t patch11_data[] = {
    0x0E, 0x1D, 0x56, 0x56, 0x56, 0xFE, 0xEE, 0xFB, 
  };
  APPLY_PATCH(11);

  uint32_t patch12_addr = 0x000083A4;
  uint8_t patch12_data[] = {
    0x0E, 0x18, 0x08, 0x56, 0x56, 0xF3, 0xEE, 0xFA, 
  };
  APPLY_PATCH(12);

  uint32_t patch13_addr = 0x000083AE;
  uint8_t patch13_data[] = {
    0x18, 0x0F, 0x01, 0x56, 0x56, 0x0E, 0xEE, 0xFF, 
  };
  APPLY_PATCH(13);

  uint32_t patch14_addr = 0x000083B8;
  uint8_t patch14_data[] = {
    0x0E, 0x56, 0x1C, 0x0B, 0x56, 0xF3, 0xEE, 0xFF, 
  };
  APPLY_PATCH(14);

  uint32_t patch15_addr = 0x000083C2;
  uint8_t patch15_data[] = {
    0x07, 0x04, 0x56, 0x56, 0x56, 0xF3, 0xEE, 0x19, 
  };
  APPLY_PATCH(15);

  uint32_t patch16_addr = 0x000083CC;
  uint8_t patch16_data[] = {
    0x01, 0x76, 0x0E, 
  };
  APPLY_PATCH(16);

  uint32_t patch17_addr = 0x000083D0;
  uint8_t patch17_data[] = {
    0x0D, 0x1A, 0x04, 0x18, 0x09, 0x0D, 
  };
  APPLY_PATCH(17);

  uint32_t patch18_addr = 0x000083D8;
  uint8_t patch18_data[] = {
    0xBB, 0xB9, 0x0E, 0x18, 0x18, 0x76, 0x6F, 0xB6, 0x6F, 0x8C, 0x03, 
  };
  APPLY_PATCH(18);

  uint32_t patch19_addr = 0x000083E4;
  uint8_t patch19_data[] = {
    0x7B, 0x70, 0x7E, 0x71, 0x72, 0x72, 0x79, 
  };
  APPLY_PATCH(19);

  uint32_t patch20_addr = 0x000083EC;
  uint8_t patch20_data[] = {
    0xF0, 0xFE, 0xFC, 0xFA, 0xF8, 0x1D, 0x1B, 0x19, 0xCF, 0x76, 0xAA, 0xCF, 0x76, 0x30, 0x4A, 0x76, 
    0x0A, 0x7B, 0xE2, 0x8F, 0x77, 0xD6, 0x8F, 0x77, 0xCA, 
  };
  APPLY_PATCH(20);

  uint32_t patch21_addr = 0x00008406;
  uint8_t patch21_data[] = {
    0x8F, 0x77, 0xAE, 0x4A, 0x76, 0x0A, 0x7B, 0xA6, 0x8F, 0x77, 0x7A, 0xCF, 0x77, 0xCA, 0x4A, 0x76, 
    0x5C, 0x78, 0xB7, 0x7B, 0x98, 0x4A, 0x76, 0x0A, 0x7B, 0x26, 0x8F, 0x77, 0x56, 0xCF, 0x77, 0xCA, 
    0x4A, 0x76, 0x5C, 0x70, 0xB7, 0x7B, 0x18, 0x4A, 0x76, 0x0A, 0x7B, 0xA6, 0x8F, 0x77, 0x42, 0xCF, 
    0x77, 0xCA, 0x4A, 0x76, 0x5C, 0x7E, 0xB7, 0x7B, 0x98, 0x4A, 0x76, 0x0A, 0x7B, 0x26, 0x8F, 0x77, 
    0x3E, 0xCF, 0x77, 0xCA, 0x4A, 0x76, 0x5C, 0x71, 0xB7, 0x7B, 0x18, 0x4A, 0x76, 0x0A, 0x7B, 0xA6, 
    0x8F, 0x77, 0x2A, 0xCF, 0x77, 0xCA, 0x4A, 0x76, 0x5C, 0x72, 0xB7, 0x7B, 0x98, 0x4A, 0x76, 0x0A, 
    0x7B, 0x26, 0x8F, 0x77, 0x06, 0xCF, 0x77, 0xCA, 0x4A, 0x76, 0x5C, 0x72, 0xB7, 0x7B, 0x18, 0x4A, 
    0x76, 0x0A, 0x7B, 0xA6, 0x8F, 0x77, 0xF2, 0xCF, 0x77, 0xCA, 0x4A, 0x76, 0x5C, 0x79, 0xB7, 0x7B, 
    0x98, 0x4A, 0x76, 0x0A, 0x7B, 0x60, 0x8F, 0x77, 0xC6, 0xCF, 0x77, 0xCA, 0x0F, 0x7D, 0x8C, 0x0F, 
    0x7D, 0x96, 0x8F, 0x7D, 0x72, 0x7D, 0x94, 0x8A, 0x75, 0x7D, 0x92, 0x0F, 0x7D, 0x90, 0x0F, 0x7D, 
    0x9E, 0x0F, 0x7D, 0x9C, 0x0F, 0x7D, 0x9A, 0x0F, 0x7D, 0x8A, 0x03, 
  };
  APPLY_PATCH(21);

  uint32_t patch22_addr = 0x000084B2;
  uint8_t patch22_data[] = {
    0x4F, 0x7D, 0x96, 0x4A, 0x76, 0x44, 0x76, 0x36, 0x76, 0x72, 0x37, 0x76, 0x37, 0x77, 0xB7, 0x7B, 
    0x90, 0x4A, 0x56, 0xB6, 0x7B, 0x12, 0xB6, 0x7B, 0x1E, 0x4F, 0x7D, 0x94, 0x4A, 0x76, 0x44, 0x76, 
    0x36, 0x76, 0x6E, 0x4A, 0x76, 0x0A, 0x7B, 0x12, 0x8F, 0x77, 0xEE, 0xCF, 0x77, 0xCA, 0x64, 0x4F, 
    0x7D, 0x73, 0x72, 0x37, 0x76, 0xB7, 0x7B, 0x10, 0x4F, 0x7D, 0x92, 0x4A, 0x76, 0x44, 0x76, 0x36, 
    0x75, 0x72, 0x37, 0x76, 0xB7, 0x7B, 0x90, 0x4F, 0x7D, 0x90, 0x4A, 0x76, 0x44, 0x76, 0x36, 0x76, 
    0x72, 0x37, 0x76, 0xB7, 0x7B, 0x10, 0x4A, 0x56, 0xB6, 0x7B, 0x92, 0x4F, 0x7D, 0x9E, 0x4A, 0x76, 
    0x44, 0x76, 0x36, 0x76, 0x6E, 0x4A, 0x76, 0x0A, 0x7B, 0x92, 0x8F, 0x77, 0xEA, 0xCF, 0x77, 0xCA, 
    0x70, 0xB7, 0x7B, 0x90, 0x4F, 0x7D, 0x9C, 0x4A, 0x76, 0x44, 0x76, 0x36, 0x76, 0x72, 0x37, 0x76, 
    0xB7, 0x7B, 0x10, 0x4F, 0x7D, 0x9A, 0x4A, 0x76, 0x44, 0x76, 0x36, 0x76, 0x72, 0x37, 0x76, 0xB7, 
    0x7B, 0x90, 0x4A, 0x56, 0xB6, 0x7B, 0xB8, 0xB6, 0x7B, 0x38, 0xB6, 0x7B, 0xB8, 0xB6, 0x7B, 0x38, 
    0xB6, 0x7B, 0xB8, 0xB6, 0x7B, 0x38, 0xB6, 0x7B, 0xB8, 0x8F, 0x7B, 0xB8, 0x4F, 0x7D, 0x8C, 0x3E, 
    0xB6, 0x4A, 0x5C, 0xF6, 0x03, 
  };
  APPLY_PATCH(22);

  uint32_t patch23_addr = 0x00008568;
  uint8_t patch23_data[] = {
    0x31, 0x71, 0x38, 0x30, 0x71, 0x4F, 0x7D, 0x8A, 0x31, 0x30, 0xB0, 0x7D, 0x8A, 0x71, 0x31, 0x7A, 
    0x7C, 0x70, 0x31, 0x75, 0x40, 0x03, 0x70, 0x71, 0x75, 0x62, 0x4F, 0x7D, 0x8C, 0x36, 0x74, 0x70, 
    0xB6, 0x7D, 0x8C, 0x03, 0x4F, 0x7D, 0x8C, 0x36, 0x36, 0x71, 0x74, 0x76, 0xB6, 0x7D, 0x8C, 0x03, 
    0x8F, 0x7D, 0x96, 0x8F, 0x77, 0xBE, 0x4F, 0x7D, 0x8C, 0x36, 0x86, 0x76, 0x70, 0x71, 0x76, 0x66, 
    0x66, 0x07, 0x76, 0x72, 0x26, 0x03, 0x26, 0x03, 0x66, 0x72, 0x26, 0x03, 0xC7, 0x76, 0x03, 
  };
  APPLY_PATCH(23);

  uint32_t patch24_addr = 0x000085B8;
  uint8_t patch24_data[] = {
    0x8F, 0x77, 0xC2, 0x0F, 0x7D, 
  };
  APPLY_PATCH(24);

  uint32_t patch25_addr = 0x000085BE;
  uint8_t patch25_data[] = {
    0x0F, 0x69, 0x7D, 
  };
  APPLY_PATCH(25);

  uint32_t patch26_addr = 0x000085C2;
  uint8_t patch26_data[] = {
    0x0F, 0x7B, 0x7D, 
  };
  APPLY_PATCH(26);

  uint32_t patch27_addr = 0x000085C6;
  uint8_t patch27_data[] = {
    0x62, 0x8F, 0x77, 0xA6, 0x0F, 0x7D, 0x74, 0x70, 0x8F, 0x77, 0x86, 0x8F, 0x76, 0xEE, 0x8A, 0x75, 
    0x7D, 0x58, 0x4F, 0x73, 0x7A, 0x7F, 0x74, 0x03, 0xF9, 0xCF, 0x77, 0x7A, 0xCF, 0x76, 0xAA, 0xCF, 
    0x77, 0x06, 0xCF, 0x76, 0xCE, 0xCF, 0x77, 0x12, 0x4F, 0x7A, 0x74, 0xCF, 0x77, 0xA6, 0x0F, 0x7D, 
    0x74, 0xA4, 0x4F, 0x7A, 0x76, 0x31, 0x31, 0x6E, 0xB0, 0x71, 0x72, 0x5A, 0x8F, 0x76, 0x7D, 0x76, 
    0x8F, 0x76, 0x7D, 0x5C, 0x0F, 0x7D, 0x74, 0x8F, 0x7D, 0x94, 0x7D, 0x5E, 0x0F, 0x7D, 0x5C, 0xCF, 
    0x76, 0xAA, 0x0F, 0x7D, 0x74, 0x72, 0x71, 0x75, 0x50, 0x8F, 0x77, 0x7D, 0x76, 0x8F, 0x77, 0x7D, 
    0x5C, 0x0F, 0x7D, 0x74, 0x8F, 0x7D, 0x94, 0x7D, 0x5E, 0x0F, 0x7D, 0x5C, 0x8F, 0x71, 0x7D, 0x76, 
    0x76, 0x0F, 0x7D, 0x56, 0x0F, 0x7D, 0x58, 0xCF, 0x7D, 0x32, 0xCF, 0x7D, 0x32, 0x8A, 0x76, 0x7D, 
    0x20, 0x8A, 0x76, 0x7D, 0x20, 0x0F, 0x7D, 0x0E, 0x0F, 0x7D, 0x0E, 0xCF, 0x7D, 0x12, 0xCF, 0x7D, 
    0x1E, 0xCF, 0x7D, 0x46, 0xCF, 0x7D, 0x42, 0x4F, 0x7D, 0x70, 0x2E, 0x36, 0x70, 0x8F, 0x76, 0xE0, 
    0x83, 0x76, 0x7D, 0x36, 0x0F, 0x7D, 0xFA, 0x8F, 0x7D, 0x96, 0x7D, 0x56, 0x8F, 0x7D, 0x92, 0x7D, 
    0x58, 0x8F, 0x7D, 0x92, 0x7D, 0x58, 0x8F, 0x7D, 0x90, 0x7D, 0x08, 0x8F, 0x7D, 0x90, 0x7D, 0x08, 
    0x4F, 0x7D, 0x9A, 0x3E, 0x0F, 0x7D, 0x9C, 0xB6, 0x7D, 0x0E, 0xB6, 0x7D, 0x0E, 0x4F, 0x7D, 0x9E, 
    0x36, 0x77, 0x72, 0x4A, 0x76, 0xB6, 0x7D, 0x20, 0xB6, 0x7D, 0x20, 0x8F, 0x76, 0x9E, 
  };
  APPLY_PATCH(27);
}

void patch_8rom()
{
  uint32_t patch0_addr = 0x00000001;
  uint8_t patch0_data[] = {
    0xFF, 
  };
  APPLY_PATCH(0);

  uint32_t patch1_addr = 0x000047C7;
  uint8_t patch1_data[] = {
    0x06, 0x42, 0xE4, 
  };
  APPLY_PATCH(1);

  uint32_t patch2_addr = 0x00004990;
  uint8_t patch2_data[] = {
    0x0C, 
  };
  APPLY_PATCH(2);

  uint32_t patch3_addr = 0x00004992;
  uint8_t patch3_data[] = {
    0x96, 
  };
  APPLY_PATCH(3);

  uint32_t patch4_addr = 0x000061AE;
  uint8_t patch4_data[] = {
    0x7D, 
  };
  APPLY_PATCH(4);

  uint32_t patch5_addr = 0x000061B0;
  uint8_t patch5_data[] = {
    0x0B, 0x35, 
  };
  APPLY_PATCH(5);

  uint32_t patch6_addr = 0x0000696F;
  uint8_t patch6_data[] = {
    0x70, 
  };
  APPLY_PATCH(6);

  uint32_t patch7_addr = 0x00006971;
  uint8_t patch7_data[] = {
    0x06, 
  };
  APPLY_PATCH(7);

  uint32_t patch8_addr = 0x00006E27;
  uint8_t patch8_data[] = {
    0x2F, 0xB7, 0x66, 0xB6, 
  };
  APPLY_PATCH(8);

  uint32_t patch9_addr = 0x00008328;
  uint8_t patch9_data[] = {
    0x06, 0x0C, 0x46, 0x4E, 0x4E, 0x4E, 0x29, 0xAC, 
  };
  APPLY_PATCH(9);

  uint32_t patch10_addr = 0x00008331;
  uint8_t patch10_data[] = {
    0x4E, 0xC1, 0x46, 0x4E, 0x29, 0xDD, 0x4E, 0x03, 0x4F, 0x1F, 0xB1, 
  };
  APPLY_PATCH(10);

  uint32_t patch11_addr = 0x0000833E;
  uint8_t patch11_data[] = {
    0x44, 0xB1, 0x4E, 0xB1, 0x0C, 0x4E, 0xDE, 
  };
  APPLY_PATCH(11);

  uint32_t patch12_addr = 0x00008346;
  uint8_t patch12_data[] = {
    0x70, 0x4E, 0x4E, 0x04, 0x4E, 0xB1, 0x24, 
  };
  APPLY_PATCH(12);

  uint32_t patch13_addr = 0x0000834E;
  uint8_t patch13_data[] = {
    0x46, 0x4E, 0x28, 0x46, 0x4E, 0x46, 0x4E, 0x28, 0x46, 0x4E, 
  };
  APPLY_PATCH(13);

  uint32_t patch14_addr = 0x0000835A;
  uint8_t patch14_data[] = {
    0x46, 0x4E, 0x4C, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0xCF, 0x36, 0x4E, 
    0x4C, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0xCF, 
  };
  APPLY_PATCH(14);

  uint32_t patch15_addr = 0x00008378;
  uint8_t patch15_data[] = {
    0x36, 0x4E, 0x4C, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0x4F, 0xCF, 0x32, 0x24, 
    0x20, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x4E, 
  };
  APPLY_PATCH(15);

  uint32_t patch16_addr = 0x00008390;
  uint8_t patch16_data[] = {
    0x32, 0x36, 0x3A, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x4E, 
  };
  APPLY_PATCH(16);

  uint32_t patch17_addr = 0x0000839A;
  uint8_t patch17_data[] = {
    0x25, 0x38, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x4E, 
  };
  APPLY_PATCH(17);

  uint32_t patch18_addr = 0x000083A4;
  uint8_t patch18_data[] = {
    0x37, 0xCE, 0x35, 0x37, 0x6E, 0x6E, 0x6E, 0x6E, 0x4E, 
  };
  APPLY_PATCH(18);

  uint32_t patch19_addr = 0x000083AE;
  uint8_t patch19_data[] = {
    0xCE, 0x24, 0x36, 0x6E, 0x6E, 0x39, 0x6E, 0x6E, 0x4E, 
  };
  APPLY_PATCH(19);

  uint32_t patch20_addr = 0x000083B8;
  uint8_t patch20_data[] = {
    0x25, 0x38, 0x37, 0x35, 0x6E, 0x6E, 0x6E, 0x6E, 0x4E, 
  };
  APPLY_PATCH(20);

  uint32_t patch21_addr = 0x000083C2;
  uint8_t patch21_data[] = {
    0x22, 0x24, 0x39, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x4E, 
  };
  APPLY_PATCH(21);

  uint32_t patch22_addr = 0x000083CC;
  uint8_t patch22_data[] = {
    0x3C, 0x21, 0x39, 0x4E, 0x37, 0x24, 0x33, 0x22, 0x6E, 0x20, 0x4E, 
  };
  APPLY_PATCH(22);

  uint32_t patch23_addr = 0x000083D8;
  uint8_t patch23_data[] = {
    0x82, 0x80, 0x21, 0x35, 0x31, 0x35, 0x5E, 0x7E, 0x5E, 0x28, 
  };
  APPLY_PATCH(23);

  uint32_t patch24_addr = 0x000083E4;
  uint8_t patch24_data[] = {
    0x4E, 0x4E, 0x4E, 0x4E, 0x4E, 0x4E, 0x4E, 
  };
  APPLY_PATCH(24);

  uint32_t patch25_addr = 0x000083EC;
  uint8_t patch25_data[] = {
    0xCB, 0xC9, 0xC7, 0xC5, 0xC3, 0x24, 0x22, 0x20, 
  };
  APPLY_PATCH(25);

  uint32_t patch26_addr = 0x000083F5;
  uint8_t patch26_data[] = {
    0x4E, 0xDD, 
  };
  APPLY_PATCH(26);

  uint32_t patch27_addr = 0x000083F8;
  uint8_t patch27_data[] = {
    0x4E, 0x9B, 0x7E, 0x4E, 0x6E, 0x4E, 0x4D, 0x0D, 0x4E, 0x49, 
  };
  APPLY_PATCH(27);

  uint32_t patch28_addr = 0x00008403;
  uint8_t patch28_data[] = {
    0x4E, 0x49, 
  };
  APPLY_PATCH(28);

  uint32_t patch29_addr = 0x00008406;
  uint8_t patch29_data[] = {
    0x0B, 0x4E, 0x49, 0x7E, 0x0E, 0x6E, 0x4E, 0x48, 0x0D, 0x4E, 0x49, 
  };
  APPLY_PATCH(29);

  uint32_t patch30_addr = 0x00008412;
  uint8_t patch30_data[] = {
    0x4E, 0x49, 0x7C, 0x4E, 0x5C, 0x4E, 0x7D, 0x4E, 0x48, 0x7E, 0x0E, 0x6E, 0x4E, 0x48, 0x0D, 0x4E, 
    0x49, 
  };
  APPLY_PATCH(30);

  uint32_t patch31_addr = 0x00008424;
  uint8_t patch31_data[] = {
    0x4E, 0x49, 0x7C, 0x4E, 0x5C, 0x4E, 0x7D, 0x4E, 0x48, 0x7E, 0x0E, 0x6E, 0x4E, 0x4B, 0x0D, 0x4E, 
    0x49, 
  };
  APPLY_PATCH(31);

  uint32_t patch32_addr = 0x00008436;
  uint8_t patch32_data[] = {
    0x4E, 0x49, 0x7C, 0x4E, 0x5C, 0x4E, 0x7D, 0x4E, 0x4B, 0x7E, 0x0E, 0x6E, 0x4E, 0x4B, 0x0D, 0x4E, 
    0x49, 
  };
  APPLY_PATCH(32);

  uint32_t patch33_addr = 0x00008448;
  uint8_t patch33_data[] = {
    0x4E, 0x49, 0x7C, 0x4E, 0x5C, 0x4E, 0x7D, 0x4E, 0x4B, 0x7E, 0x0E, 0x6E, 0x4E, 0x4A, 0x0D, 0x4E, 
    0x49, 
  };
  APPLY_PATCH(33);

  uint32_t patch34_addr = 0x0000845A;
  uint8_t patch34_data[] = {
    0x4E, 0x49, 0x7C, 0x4E, 0x5C, 0x4E, 0x7D, 0x4E, 0x4A, 0x7E, 0x0E, 0x6E, 0x4E, 0x4A, 0x0D, 0x4E, 
    0x49, 
  };
  APPLY_PATCH(34);

  uint32_t patch35_addr = 0x0000846C;
  uint8_t patch35_data[] = {
    0x4E, 0x49, 0x7C, 0x4E, 0x5C, 0x4E, 0x7D, 0x4E, 0x4A, 0x7E, 0x0E, 0x6E, 0x4E, 0x4D, 0x0D, 0x4E, 
    0x49, 
  };
  APPLY_PATCH(35);

  uint32_t patch36_addr = 0x0000847E;
  uint8_t patch36_data[] = {
    0x4E, 0x49, 0x7C, 0x4E, 0x5C, 0x4E, 0x7D, 0x4E, 0x4D, 0x7E, 0x0E, 0x6E, 0x4E, 0x4D, 0x0D, 0x4E, 
    0x49, 
  };
  APPLY_PATCH(36);

  uint32_t patch37_addr = 0x00008490;
  uint8_t patch37_data[] = {
    0x4E, 0x49, 0x0C, 0x4E, 0xB1, 0x0C, 0x4E, 0xB1, 0x7D, 0x4E, 0xDE, 0x4E, 0xB1, 0x7D, 0x4E, 0x4E, 
    0xB1, 0x0C, 0x4E, 0xB1, 0x0C, 0x4E, 0xB1, 0x0C, 0x4E, 0xB1, 0x0C, 0x4E, 0xB1, 0x0C, 0x4E, 0xB1, 
  };
  APPLY_PATCH(37);

  uint32_t patch38_addr = 0x000084B2;
  uint8_t patch38_data[] = {
    0x7E, 0x4E, 0xB1, 0x7C, 0xDE, 0x5C, 0x4E, 0x42, 0x4E, 0x29, 0x4A, 0x5E, 0x48, 0x4E, 0x7D, 0x4E, 
    0x48, 0x7E, 0x4E, 0x7D, 0x4E, 0x48, 0x7D, 0x4E, 0x48, 0x7E, 0x4E, 0xB1, 0x7C, 0xDE, 0x5C, 0x4E, 
    0x42, 0x4E, 0x28, 0x7E, 0xCE, 0x6E, 0x4E, 0x48, 0x0D, 0x4E, 0x49, 
  };
  APPLY_PATCH(38);

  uint32_t patch39_addr = 0x000084DE;
  uint8_t patch39_data[] = {
    0x4E, 0x49, 0x2E, 0xFE, 0x4E, 0xDE, 0x29, 0x4A, 0x5E, 0x7D, 0x4E, 0x48, 0x7E, 0x4E, 0xB1, 0x7C, 
    0xDE, 0x5C, 0x4E, 0x42, 0x4E, 0x29, 0x4A, 0x5E, 0x7D, 0x4E, 0x4B, 0x7E, 0x4E, 0xB1, 0x7C, 0xDE, 
    0x5C, 0x4E, 0x42, 0x4E, 0x29, 0x4A, 0x5E, 0x7D, 0x4E, 0x4B, 0x7E, 0x4E, 0x7D, 0x4E, 0x4A, 0x7E, 
    0x4E, 0xB1, 0x7C, 0xCE, 0x5C, 0x4E, 0x42, 0x4E, 0x28, 0x7E, 0xDE, 0x6E, 0x4E, 0x4A, 0x0D, 0x4E, 
    0x49, 
  };
  APPLY_PATCH(39);

  uint32_t patch40_addr = 0x00008520;
  uint8_t patch40_data[] = {
    0x4E, 0x49, 0x2E, 0x7D, 0x4E, 0x4A, 0x7E, 0x4E, 0xB1, 0x7C, 0xDE, 0x5C, 0x4E, 0x42, 0x4E, 0x29, 
    0x4A, 0x5E, 0x7D, 0x4E, 0x4A, 0x7E, 0x4E, 0xB1, 0x7C, 0xDE, 0x5C, 0x4E, 0x42, 0x4E, 0x29, 0x4A, 
    0x5E, 0x7D, 0x4E, 0x4D, 0x7E, 0x4E, 0x7D, 0x4E, 0x48, 0x7D, 0x4E, 0x48, 0x7D, 0x4E, 0x4B, 0x7D, 
    0x4E, 0x4B, 0x7D, 0x4E, 0x4A, 0x7D, 0x4E, 0x4A, 0x7D, 0x4E, 0x4D, 0x0F, 0x4E, 0x48, 0x7E, 0x4E, 
    0xB1, 0xA1, 0xDE, 0x7E, 0x4E, 0x7E, 
  };
  APPLY_PATCH(40);

  uint32_t patch41_addr = 0x00008568;
  uint8_t patch41_data[] = {
    0x08, 0x72, 0xAE, 0xC0, 0x72, 0x7E, 0x4E, 0xB1, 0xFF, 0x80, 0x7D, 0x4E, 0xB1, 0x72, 0x4C, 0x4E, 
    0x28, 0x70, 0x4C, 0x4E, 0x28, 
  };
  APPLY_PATCH(41);

  uint32_t patch42_addr = 0x0000857E;
  uint8_t patch42_data[] = {
    0x70, 0x46, 0x4E, 0x29, 0x7E, 0x4E, 0xB1, 0x1D, 0x2A, 0x3E, 0x7D, 0x4E, 0xB1, 
  };
  APPLY_PATCH(42);

  uint32_t patch43_addr = 0x0000858C;
  uint8_t patch43_data[] = {
    0x7E, 0x4E, 0xB1, 0x1C, 0x42, 0x4E, 0x28, 0x3E, 0x7D, 0x4E, 0xB1, 
  };
  APPLY_PATCH(43);

  uint32_t patch44_addr = 0x00008598;
  uint8_t patch44_data[] = {
    0x0F, 0x4E, 0xB1, 0x0D, 0x4E, 0x49, 0x7E, 0x4E, 0xB1, 0x9E, 0x0F, 0x4E, 0x70, 0x46, 0x4E, 0x29, 
    0x7C, 0xFC, 0x4E, 0x29, 0x1C, 
  };
  APPLY_PATCH(44);

  uint32_t patch45_addr = 0x000085AE;
  uint8_t patch45_data[] = {
    0x0C, 
  };
  APPLY_PATCH(45);

  uint32_t patch46_addr = 0x000085B0;
  uint8_t patch46_data[] = {
    0x7C, 0x29, 0x1D, 
  };
  APPLY_PATCH(46);

  uint32_t patch47_addr = 0x000085B4;
  uint8_t patch47_data[] = {
    0x7E, 0x4E, 
  };
  APPLY_PATCH(47);

  uint32_t patch48_addr = 0x000085B8;
  uint8_t patch48_data[] = {
    0x03, 0x4E, 0x48, 0x1C, 0x4E, 0xDE, 0x4C, 0x4E, 0x4E, 0xDE, 0x42, 0x4E, 0x4E, 0xDE, 0x2A, 0x03, 
    0x4E, 0x48, 0x04, 0x4E, 0xDE, 0x28, 0x03, 0x4E, 0x48, 
  };
  APPLY_PATCH(48);

  uint32_t patch49_addr = 0x000085D2;
  uint8_t patch49_data[] = {
    0x4E, 0x95, 0x7D, 0x4E, 0x4E, 0x35, 0x46, 0x4E, 0x4E, 0x4E, 0x29, 
  };
  APPLY_PATCH(49);

  uint32_t patch50_addr = 0x000085DE;
  uint8_t patch50_data[] = {
    0x16, 
  };
  APPLY_PATCH(50);

  uint32_t patch51_addr = 0x000085E0;
  uint8_t patch51_data[] = {
    0x4E, 0x46, 
  };
  APPLY_PATCH(51);

  uint32_t patch52_addr = 0x000085E3;
  uint8_t patch52_data[] = {
    0x4E, 0xDD, 
  };
  APPLY_PATCH(52);

  uint32_t patch53_addr = 0x000085E6;
  uint8_t patch53_data[] = {
    0x4E, 0x45, 
  };
  APPLY_PATCH(53);

  uint32_t patch54_addr = 0x000085E9;
  uint8_t patch54_data[] = {
    0x4E, 0x8A, 
  };
  APPLY_PATCH(54);

  uint32_t patch55_addr = 0x000085EC;
  uint8_t patch55_data[] = {
    0x4E, 0x47, 0x70, 0x4E, 0x4E, 
  };
  APPLY_PATCH(55);

  uint32_t patch56_addr = 0x000085F2;
  uint8_t patch56_data[] = {
    0x4E, 0x44, 0x04, 0x4E, 0xDE, 0x29, 0x70, 0x4E, 0x4E, 0x08, 0x4C, 0x4E, 0x29, 0x46, 0x4E, 0x29, 
    0x46, 0x4E, 0x4E, 0xDE, 0x46, 0x4E, 0x4E, 0xDE, 0x1D, 0x4E, 0xDE, 0x7D, 0x4E, 0xB1, 0x4E, 0x35, 
    0x0C, 0x4E, 0x35, 
  };
  APPLY_PATCH(56);

  uint32_t patch57_addr = 0x00008616;
  uint8_t patch57_data[] = {
    0x4E, 0xDD, 0x04, 0x4E, 0xDE, 0x29, 0x46, 0x4E, 0x29, 0x46, 0x4E, 0x4E, 0xDE, 0x46, 0x4E, 0x4E, 
    0xDE, 0x1D, 0x4E, 0xDE, 0x7D, 0x4E, 0xB1, 0x4E, 0x34, 0x0C, 0x4E, 0x35, 0x46, 0x4E, 0x4E, 0xDE, 
    0x30, 0x0C, 0x4E, 0xDE, 0x0C, 0x4E, 0xDE, 0x0C, 0x4E, 0x34, 0x0C, 0x4E, 0x35, 0x7D, 0xCE, 0x4E, 
    0x34, 0x7D, 0xCE, 0x4E, 0x34, 0x0C, 0x4E, 0x34, 0x0C, 0x4E, 0x34, 0x0C, 0x4E, 0xDE, 0x0C, 0x4E, 
    0xDE, 0x0C, 0x4E, 0xDE, 0x0C, 0x4E, 0xDE, 0x7E, 0x4E, 0xDE, 0xA1, 0x4C, 0x4E, 0x05, 0x4E, 0xA5, 
    0x7D, 0x4E, 0x4E, 0xDE, 0x0C, 0x4E, 0xDE, 0x7D, 0x4E, 0xB1, 0x4E, 0xDE, 0x7D, 0x4E, 0xB1, 0x4E, 
    0x34, 0x7D, 0x4E, 0xB1, 0x4E, 0x35, 0x7D, 0x4E, 0xB1, 0x4E, 0x34, 0x7D, 0x4E, 0xB1, 0x4E, 0x35, 
    0x7E, 0x4E, 0xB1, 0xAF, 0xCE, 0x4E, 0xB1, 0x7D, 0x4E, 0x34, 0x7D, 0x4E, 0x35, 0x7E, 0x4E, 0xB1, 
    0x4A, 0x4E, 0x2A, 0x7E, 0xCE, 0x7D, 0x4E, 0x34, 0x7D, 0x4E, 0x35, 
  };
  APPLY_PATCH(57);

  uint32_t patch58_addr = 0x000086A2;
  uint8_t patch58_data[] = {
    0x4E, 0xC3, 
  };
  APPLY_PATCH(58);
}

void loadrom(int rom)
{
}

void patching(int rom)
{
  switch(rom) {
    case 0:
      patch_7rom();
      break;
    case 1:
      patch_8rom();
      break;
    default:
      fprintf(stderr, "Bad patch ROM ID %d\n", rom);
      break;
  }
}

void saverom(int rom)
{
}

